'***************************************************************************************
'*                                                                                     *
'*  Ganganzeige V1.2 by Ati mit einem Open-Micro fr SV650                             *
'*                                                                                     *
'***************************************************************************************

' --- Betriebssystem konfigurieren -----------------------------------------------------
include "om.def"                        ' Definitionen fuer Betriebssystem
RunOnErr = on                           ' bei Fehler Programm neustarten (Fehler in ERR)
PullUpA = 0                             ' Pull-Up-Widerstnde - aus
'---------------------------------------------------------------------------------------


'--- Definitionen der QT4 & QY4 Ports --------------------------------------------------
define Sensor         ad[1]             'A-Port1 / Eingang Sensor
define outputB      port[2]             'A-Port2 / BCD Ausgang B
define frei1        port[3]             'A-Port3 / host-run auf High legen
define outputC      port[4]             'A-Port4 / BCD Ausgang C
define outputD      port[5]             'A-Port5 / BCD Ausgang D
define outputA      port[6]             'A-Port6 / BCD Ausgang A
'---------------------------------------------------------------------------------------

'--- Initialisierung Hard und Software -------------------------------------------------
' Es werden jetzt kurz nacheinander die Zahlen 8 und 0 bis 6 angezeigt. Danach beginnt
' das eigentliche Programm.
'--------------------
Initial : pause 12			       ' Anzeige 8 auf dem Display
Leerlauf : pause 6                             ' Anzeige 0 auf dem Display
Gang_1 : pause 6                               ' Anzeige 1 auf dem Display
Gang_2 : pause 6                               ' Anzeige 2 auf dem Display
Gang_3 : pause 6                               ' Anzeige 3 auf dem Display
Gang_4 : pause 6                               ' Anzeige 4 auf dem Display
Gang_5 : pause 6                               ' Anzeige 5 auf dem Display
Gang_6 : pause 6                               ' Anzeige 6 auf dem Display
Fehler : pause 6                               ' Anzeige E auf dem Display
Display_aus : pause 12                         ' Anzeige aus laut Datenblatt B348
'---------------------------------------------------------------------------------------




'--- Hauptprogramm ---------------------------------------------------------------------
' Es wird nun alle 0,5 Sekunden der Gang-Sensor abgefragt.
'--------------------
#start                                          'Programmanfang
if Sensor>=50 and Sensor<=70 then
     gosub Gang_1                               'Anzeige - Gang 1
else if Sensor>=71 and Sensor<=100 then
     gosub Gang_2                               'Anzeige - Gang 2
else if Sensor>=101 and Sensor<=135 then
     gosub Gang_3                               'Anzeige - Gang 3
else if Sensor>=136 and Sensor<=170 then
     gosub Gang_4                               'Anzeige - Gang 4
else if Sensor>=171 and Sensor<=202 then
     gosub Gang_5                               'Anzeige - Gang 5
else if Sensor>=203 and Sensor<=225 then
     gosub Gang_6                               'Anzeige - Gang 6
else if Sensor>=226 then
     gosub Leerlauf                             'Anzeige - Leerlauf
else if Sensor>=0 and Sensor<49 then
     gosub Fehler                               'Anzeige - Error
end if
pause 12				        'Pause 240 Millisekunden
goto start                                      'zum Programmanfang
end
'---------------------------------------------------------------------------------------




'--- Display AUS -----------------------------------------------------------------------
' Es wird dass Display abgeschaltet (keine Zahlen sichtbar, es steht ein - )
'--------------------
FUNC Display_aus
  outputA = off                                 'BCD Pin-A = aus
  outputB = on                                  'BCD Pin-B = ein
  outputc = off                                 'BCD Pin-C = aus
  outputD = on                                  'BCD Pin-D = ein
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Leerlauf --------------------------------------------------------------------------
' Es wird eine 0 auf dem Display angezeigt.
'--------------------
FUNC Leerlauf
  outputA = off                                 'BCD Pin-A = aus
  outputB = off                                 'BCD Pin-B = aus
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 1 ----------------------------------------------------------------------------
' Es wird eine 1 auf dem Display angezeigt.
'--------------------
FUNC Gang_1
  outputA = on                                  'BCD Pin-A = ein
  outputB = off                                 'BCD Pin-B = aus
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 2 ----------------------------------------------------------------------------
' Es wird eine 2 auf dem Display angezeigt.
'--------------------
FUNC Gang_2
  outputA = off                                 'BCD Pin-A = aus
  outputB = on                                  'BCD Pin-B = ein
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 3 ----------------------------------------------------------------------------
' Es wird eine 3 auf dem Display angezeigt.
'--------------------
FUNC Gang_3
  outputA = on                                  'BCD Pin-A = ein
  outputB = on                                  'BCD Pin-B = ein
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 4 ----------------------------------------------------------------------------
' Es wird eine 4 auf dem Display angezeigt.
'--------------------
FUNC Gang_4
  outputA = off                                 'BCD Pin-A = aus
  outputB = off                                 'BCD Pin-B = aus
  outputC = on                                  'BCD Pin-C = ein
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 5 ----------------------------------------------------------------------------
' Es wird eine 5 auf dem Display angezeigt.
'--------------------
FUNC Gang_5
  outputA = on                                  'BCD Pin-A = ein
  outputB = off                                 'BCD Pin-B = aus
  outputC = on                                  'BCD Pin-C = ein
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 6 ----------------------------------------------------------------------------
' Es wird eine 6 auf dem Display angezeigt.
'--------------------
FUNC Gang_6
  outputA = off                                 'BCD Pin-A = aus
  outputB = on                                  'BCD Pin-B = ein
  outputC = on                                  'BCD Pin-C = ein
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'---Initialisierung---------------------------------------------------------------------
' Es wird eine 8 auf dem Display angezeigt.
'-------------------
FUNC Initial
  outputA = off					'BCD Pin-A = aus
  outputB = off					'BCD Pin-B = aus
  outputC = off					'BCD Pin-C = aus
  outputD = on					'BCD Pin-D = ein
  RETURN
End FUNC
'---------------------------------------------------------------------------------------

'--- Fehler ----------------------------------------------------------------------------
' Es wird ein E fr Error auf dem Display angezeigt -> D348 bei 11
'--------------------
FUNC Fehler
  outputA = on                                 'BCD Pin-A = ein
  outputB = on                                 'BCD Pin-B = ein
  outputC = off                                'BCD Pin-C = aus
  outputD = on                                 'BCD Pin-D = ein
  RETURN
END FUNC
'---------------------------------------------------------------------------------------
End                                            'Programmende

'SV650

'1. Gang Bereich von 1,62 Volt - 2,08 Volt
'nach herunterteilen 1,52 Volt - 1,95 Volt
'Sensorwert 76 - 97

'2. Gang Bereich von 2,09 Volt - 2,66 Volt
'nach Herunterteilen 1,96 Volt - 2,50 Volt
'Sensorwert 98 - 125

'3. Gang Bereich von 2,67 Volt - 3,35 Volt
'nach Herunterteilen 2,51 Volt - 3,14 Volt
'Sensorwert 126 - 157

'4. Gang Bereich von 3,36 Volt - 4,00 Volt
'nach Herunterteilen 3,15 Volt - 3,76 Volt
'Sensorwert 158 - 188

'5. Gang Bereich von 4.01 Volt - 4,51 Volt
'nach Herunterteilen 3,77 Volt - 4,24 Volt
'Sensorwert 189 - 212

'6. Gang Bereich von 4,52 Volt - 4,83 Volt
'nach Herunterteilen 4,25 Volt - 4,54 Volt
'Sensorwert 213 - 227

'Leerlauf ab 4,84 Volt
'nach Herunterteilen 4,55 Volt
'Sensorwert 228

'entspricht 5,99% Spannungsverringerung